; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;  2010 Coma
; -------------------------------------------------------------------------
; Title         : Coma - Win32 CartoonFetcher
; Description   : Cartoon Fetcher from various websites
; Version       : 0.21
; Date          : 06.12.2010
; Company       : Coma
; Author        : Coma
; Homepage      : http://ge2001.dyndns.org:44792
;               : Online 20:00 - 23:00 GMT+2
; Email         : ge2001@yahoo.com
; -------------------------------------------------------------------------
; Assembler     : Microsoft Assembler 6.14.884 / Linker 5.12.8078 / Resource Compiler 5.00.1823.1
;               : ml.exe /c /coff Coma_Win32_CartoonFetcher.asm
;               : rc.exe /v rsrc.rc
;               : cvtres.exe /machine:ix86 rsrc.res
;               : link.exe /SUBSYSTEM:WINDOWS /OPT:NOREF Coma_Win32_CartoonFetcher.obj rsrc.res
; -------------------------------------------------------------------------
; Comments      : Freeware, use it on your own risk
;               : Masm32 download: http://movsd.com
; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

.586
.MMX
.Model Flat, StdCall
option casemap:none

include \masm32\include\kernel32.inc
include \masm32\include\user32.inc
include \masm32\include\gdi32.inc
include \masm32\include\comctl32.inc
include \masm32\include\shell32.inc
include \masm32\include\shlwapi.inc
include \masm32\include\atl.inc
;---
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\user32.lib
includelib \masm32\lib\gdi32.lib
includelib \masm32\lib\comctl32.lib
includelib \masm32\lib\shell32.lib
includelib \masm32\lib\shlwapi.lib
includelib \masm32\lib\atl.lib
;---
include \masm32\include\windows.inc

; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
.const
align 8
; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
WP_CallBack             equ [ebp+04]                ; return address
WP_hWnd                 equ [ebp+08]                ; handle window for msg
WP_uMsg                 equ [ebp+12]                ; message number
WP_wParam               equ [ebp+16]                ; extra message info
WP_lParam               equ [ebp+20]                ; extra message info
;---
MAX_PATHEX              equ 1024

; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
.data?
align 8
; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
wc                      WNDCLASSEX <>               ; Structures
msg                     MSG <>
icc                     INITCOMMONCONTROLSEX <>
cbei                    COMBOBOXEXITEM <>
ps                      PAINTSTRUCT <>
nid                     NOTIFYICONDATA <>
rc                      RECT <>
ti                      TOOLINFO <>
_st                     SYSTEMTIME <>
;---
hIcoApplication         dd ?                        ; Handle
hBmpBackground          dd ?
hBrBackground           dd ?
;---
hBrBLACK_BRUSH          dd ?
hObjectOld              dd ?
hFntArial               dd ?
hFntDefGui              dd ?
hWndIL                  dd ?
hBmpTmp                 dd ?
hWndCBCartoonSource     dd ?
hWndSTLogo              dd ?
hWndSTCount             dd ?
hWndUDCount             dd ?
hWndMC                  dd ?
hWndAtl                 dd ?
hWndTT                  dd ?
;---
hInstance               dd ?
ReturnEAX               dd ?
;---
BufferURL               db MAX_PATHEX   dup (?)     ; Buffer
BufferTmp0              db 10000 dup (?)
BufferTmp1              db 10000 dup (?)


; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
.data
align 8
; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
XorgWindow              dd 0
YorgWindow              dd 0
XmaxWindow              dd 800
YmaxWindow              dd 600
;---
XmaxMC                  dd 0
YmaxMC                  dd 0
;---
UrlDataTable            dd OFFSET UrlData_0000,OFFSET UrlData_0001,OFFSET UrlData_0002,OFFSET UrlData_0003,OFFSET UrlData_0004
                        dd OFFSET UrlData_0005,OFFSET UrlData_0006,OFFSET UrlData_0007,OFFSET UrlData_0008,OFFSET UrlData_0009
                        dd OFFSET UrlData_0010,OFFSET UrlData_0011,OFFSET UrlData_0012,OFFSET UrlData_0013,OFFSET UrlData_0014
                        dd OFFSET UrlData_0015,OFFSET UrlData_0016,OFFSET UrlData_0017,OFFSET UrlData_0018,OFFSET UrlData_0019
                        dd OFFSET UrlData_0020,OFFSET UrlData_0021,OFFSET UrlData_0022,OFFSET UrlData_0023,OFFSET UrlData_0024
                        dd OFFSET UrlData_0025,OFFSET UrlData_0026,OFFSET UrlData_0027,OFFSET UrlData_0028,OFFSET UrlData_0029
                        dd OFFSET UrlData_0030,OFFSET UrlData_0031,OFFSET UrlData_0032,OFFSET UrlData_0033,OFFSET UrlData_0034
                        dd OFFSET UrlData_0035,OFFSET UrlData_0036,OFFSET UrlData_0037,OFFSET UrlData_0038,OFFSET UrlData_0039
                        dd OFFSET UrlData_0040,OFFSET UrlData_0041,OFFSET UrlData_0042,OFFSET UrlData_0043,OFFSET UrlData_0044
                        dd OFFSET UrlData_0045,OFFSET UrlData_0046,OFFSET UrlData_0047,OFFSET UrlData_0048,OFFSET UrlData_0049

                        dd OFFSET UrlData_0050,OFFSET UrlData_0051,OFFSET UrlData_0052,OFFSET UrlData_0053,OFFSET UrlData_0054
                        dd OFFSET UrlData_0055,OFFSET UrlData_0056,OFFSET UrlData_0057,OFFSET UrlData_0058,OFFSET UrlData_0059
                        dd OFFSET UrlData_0060,OFFSET UrlData_0061,OFFSET UrlData_0062,OFFSET UrlData_0063,OFFSET UrlData_0064
                        dd OFFSET UrlData_0065,OFFSET UrlData_0066,OFFSET UrlData_0067,OFFSET UrlData_0068,OFFSET UrlData_0069
                        dd OFFSET UrlData_0070,OFFSET UrlData_0071,OFFSET UrlData_0072,OFFSET UrlData_0073,OFFSET UrlData_0074
                        dd OFFSET UrlData_0075,OFFSET UrlData_0076,OFFSET UrlData_0077,OFFSET UrlData_0078,OFFSET UrlData_0079
                        dd OFFSET UrlData_0080,OFFSET UrlData_0081,OFFSET UrlData_0082,OFFSET UrlData_0083,OFFSET UrlData_0084
                        dd OFFSET UrlData_0085,OFFSET UrlData_0086,OFFSET UrlData_0087,OFFSET UrlData_0088,OFFSET UrlData_0089
                        dd OFFSET UrlData_0090,OFFSET UrlData_0091,OFFSET UrlData_0092,OFFSET UrlData_0093,OFFSET UrlData_0094
                        dd OFFSET UrlData_0095,OFFSET UrlData_0096,OFFSET UrlData_0097,OFFSET UrlData_0098,OFFSET UrlData_0099
;---
szCN                    db "l7sdfgreoig34430erlkfl6lrgeet88e4ore40984ylks",0
szWN                    db "  2010 Coma - Cartoon Fetcher V0.21- Another Freeware coded by Coma",0
;---
szCN_Listview           db "SysListView32",0
szCN_DateTimePick       db "SysDateTimePick32",0
szCN_Calendar           db "SysMonthCal32",0
szCN_Statusbar          db "msctls_statusbar32",0
szCN_ToolTips           db "Tooltips_class32",0
szCN_UpDown             db "msctls_updown32",0
szCN_ComboBoxEx         db "ComboBoxEx32",0
szCN_Combobox           db "COMBOBOX",0
szCN_Button             db "BUTTON",0
szCN_Static             db "STATIC",0
szCN_Edit               db "EDIT",0
szCN_Listbox            db "LISTBOX",0
szCN_Atl                db "AtlAxWin",0
;----------------------------------------------------------------------------------------------------
UrlDataBlank            db 'MSHTML:<html><head></head><body oncontextmenu="return false;">'
                        db '<div align="center">'
                        db '<table>'
                        db '<tr><td valign="top" style="text-align:center; font-family:Comic Sans MS, Times, Arial; font-style:italic; font-weight:bold; font-size:1.6em; color:#808080; background-color:transparent;">Coma proudly presents the</td></tr>'
                        db '<tr><td style="text-align:center; height:100px; font-family:Comic Sans MS, Times, Arial; font-style:italic; font-weight:bold; font-size:2.0em; color:#808080; background-color:transparent;">Cartoon Fetcher</td></tr>'
                        db '<tr><td valign="bottom" style="text-align:center; height:100px; font-family:Comic Sans MS, Times, Arial; font-style:italic; font-weight:bold; font-size:0.8em; color:#C0C0C0; background-color:transparent;">'
                        db 'Done in December 2010 by Coma, please support Wikileaks, thank you.</td></tr>'
                        db '</table>'
                        db '</div></body></html>',0
UrlDataBegin            db 'MSHTML:<html><head></head><body oncontextmenu="return false;"><div align="center"><img src="',0
UrlDataEnd              db '" alt=""></div></body></html>',0
;----------------------------------------------------------------------------------------------------
                        ; URLBuilderMethod[1],IndexImageInImagelist[1],TextInCombobox[40+1],URLBase[maximal 980+1] =1024 maximal !
UrlData_0000            db 00,0,"======> No Cartoon source selected      ",0,"http://ge2001.dyndns.org:44792",0
UrlData_0001            db 01,3,"Calvin and Hobbes                       ",0,"http://picayune.uclick.com/comics/spch",0;
UrlData_0002            db 02,1,"Unshelved                               ",0,"http://www.unshelved.com/strips/",0;
UrlData_0003            db 04,2,"Nicht Lustig                            ",0,"http://www.nichtlustig.de/comics/full/",0;
UrlData_0004            db 08,2,"Die kleine Gruftschlampe                ",0,"http://www.lappan.de/galerien/gruftschlampe/",0;
UrlData_0005            db 01,1,"Calvin and Hobbes                       ",0,"http://images.ucomics.com/comics/ch",0;
UrlData_0006            db 03,4,"Hackles                                 ",0,"http://hackles.org/strips/cartoon",0;
UrlData_0007            db 04,4,"Dragon Tails                            ",0,"http://www.dragon-tails.com/comics/",0;
UrlData_0008            db 01,3,"Benitin y Eneas                         ",0,"http://picayune.uclick.com/comics/spmut",0;
UrlData_0009            db 01,3,"Cathy                                   ",0,"http://picayune.uclick.com/comics/spca",0;
UrlData_0010            db 01,3,"Condorito                               ",0,"http://picayune.uclick.com/comics/cond",0;
UrlData_0011            db 01,3,"FoxTrot                                 ",0,"http://picayune.uclick.com/comics/spft",0;
UrlData_0012            db 01,3,"Fred Bassett                            ",0,"http://picayune.uclick.com/comics/spfba",0;
UrlData_0013            db 01,3,"Garfield                                ",0,"http://picayune.uclick.com/comics/gh",0;
UrlData_0014            db 01,3,"Gaturro                                 ",0,"http://picayune.uclick.com/comics/spgat",0;
UrlData_0015            db 01,3,"Ginger Meggs                            ",0,"http://picayune.uclick.com/comics/spgin",0;
UrlData_0016            db 01,3,"Heathcliff                              ",0,"http://picayune.uclick.com/comics/crhes",0;
UrlData_0017            db 01,3,"Lio en Espaol                          ",0,"http://picayune.uclick.com/comics/splio",0;
UrlData_0018            db 01,3,"Modesty Blaise                          ",0,"http://picayune.uclick.com/comics/spmb",0;
UrlData_0019            db 01,3,"Overboard                               ",0,"http://picayune.uclick.com/comics/spob",0;
UrlData_0020            db 01,3,"Pepe                                    ",0,"http://picayune.uclick.com/comics/sppep",0;
UrlData_0021            db 01,3,"Pooch Caf                              ",0,"http://picayune.uclick.com/comics/sppoc",0;
UrlData_0022            db 01,3,"Ronaldinho Gaucho                       ",0,"http://picayune.uclick.com/comics/spron",0;
UrlData_0023            db 01,3,"Tutelandia                              ",0,"http://picayune.uclick.com/comics/sptut",0;
UrlData_0024            db 01,3,"Visiones del Mundo                      ",0,"http://picayune.uclick.com/comics/cwvws",0;
UrlData_0025            db 01,3,"The Wizard of Id                        ",0,"http://picayune.uclick.com/comics/crwis",0;
UrlData_0026            db 01,3,"Yenny                                   ",0,"http://picayune.uclick.com/comics/spyen",0;
UrlData_0027            db 01,3,"Ziggy                                   ",0,"http://picayune.uclick.com/comics/spzi",0;
UrlData_0028            db 09,2,"Kritzelwerk Tagescartoon                ",0,"http://www.kritzelwerk.de/tagescartoon/9",0;
UrlData_0029            db 12,2,"Querbilder I                            ",0,"http://www.querbilder.de/comix/",0;
UrlData_0030            db 13,2,"Querbilder II                           ",0,"http://www.querbilder.de/comix/",0;
UrlData_0031            db 08,2,"Touche                                  ",0,"http://www.lappan.de/galerien/album87/",0;
UrlData_0032            db 08,2,"Horst                                   ",0,"http://www.lappan.de/galerien/horst_dic/",0;
UrlData_0033            db 06,1,"Aford                                   ",0,"http://www.riddlesbunnybarn.com/AFORD/comicstrips/strip",0;
UrlData_0034            db 05,1,"Mother Goose and Grimm                  ",0,"http://www.grimmy.com/images/MGG_Archive/MGG",0;
UrlData_0035            db 01,1,"Garfield                                ",0,"http://images.ucomics.com/comics/ga",0;
UrlData_0036            db 07,1,"Blondie                                 ",0,"http://www.blondie.com/dailies/",0;
UrlData_0037            db 01,1,"Ziggy                                   ",0,"http://picayune.uclick.com/comics/zi",0;
UrlData_0038            db 01,1,"Winnie the Pooh                         ",0,"http://picayune.uclick.com/comics/crwin",0;
UrlData_0039            db 01,1,"Pickles                                 ",0,"http://picayune.uclick.com/comics/wppic",0;
UrlData_0040            db 01,1,"Pinkerton                               ",0,"http://picayune.uclick.com/comics/pink",0;
UrlData_0041            db 01,1,"The Pink Panther                        ",0,"http://picayune.uclick.com/comics/tmpnk",0;
UrlData_0042            db 01,1,"The Middletons                          ",0,"http://picayune.uclick.com/comics/tmmid",0;
UrlData_0043            db 01,1,"Heathcliff                              ",0,"http://picayune.uclick.com/comics/crhea",0;
UrlData_0044            db 01,1,"Matt Davies                             ",0,"http://picayune.uclick.com/comics/tmmda",0;
UrlData_0045            db 01,1,"Lalo Alcaraz                            ",0,"http://picayune.uclick.com/comics/la",0;
UrlData_0046            db 01,1,"Nick Anderson                           ",0,"http://picayune.uclick.com/comics/wpnan",0;
UrlData_0047            db 01,1,"Chuck Asay                              ",0,"http://picayune.uclick.com/comics/crcas",0;
UrlData_0048            db 01,1,"Tony Auth                               ",0,"http://picayune.uclick.com/comics/ta",0;
UrlData_0049            db 01,1,"Clay Bennett                            ",0,"http://picayune.uclick.com/comics/wpcbe",0;
UrlData_0050            db 01,1,"Lisa Benson                             ",0,"http://picayune.uclick.com/comics/wplbe",0;
UrlData_0051            db 01,1,"Chip Bok                                ",0,"http://picayune.uclick.com/comics/crcbo",0;
UrlData_0052            db 01,1,"Jim Borgman                             ",0,"http://picayune.uclick.com/comics/borg",0;
UrlData_0053            db 01,1,"Stuart Carlson                          ",0,"http://picayune.uclick.com/comics/sc",0;
UrlData_0054            db 01,1,"Ken Catalino                            ",0,"http://picayune.uclick.com/comics/crkca",0;
UrlData_0055            db 01,1,"Paul Conrad                             ",0,"http://picayune.uclick.com/comics/tmpco",0;
UrlData_0056            db 01,1,"Jeff Danziger                           ",0,"http://picayune.uclick.com/comics/jd",0;
UrlData_0057            db 01,1,"John Deering                            ",0,"http://picayune.uclick.com/comics/crjde",0;
UrlData_0058            db 01,1,"Bob Gorrell                             ",0,"http://picayune.uclick.com/comics/crbgo",0;
UrlData_0059            db 01,1,"Walt Handelsman                         ",0,"http://picayune.uclick.com/comics/tmwha",0;
UrlData_0060            db 01,1,"David Horsey                            ",0,"http://picayune.uclick.com/comics/tmdho",0;
UrlData_0061            db 01,1,"Clay Jones-                             ",0,"http://picayune.uclick.com/comics/crcjo",0;
UrlData_0062            db 01,1,"Kevin Kallaugher                        ",0,"http://picayune.uclick.com/comics/cwkal",0;
UrlData_0063            db 01,1,"Steve Kelley                            ",0,"http://picayune.uclick.com/comics/crske",0;
UrlData_0064            db 01,1,"Dick Locher                             ",0,"http://picayune.uclick.com/comics/tmdlo",0;
UrlData_0065            db 01,1,"Chan Lowe                               ",0,"http://picayune.uclick.com/comics/tmclo",0;
UrlData_0066            db 01,1,"Mike Luckovich                          ",0,"http://picayune.uclick.com/comics/crmlu",0;
UrlData_0067            db 01,1,"Glenn McCoy                             ",0,"http://picayune.uclick.com/comics/gm",0;
UrlData_0068            db 01,1,"Jim Morin                               ",0,"http://picayune.uclick.com/comics/cwjmo",0;
UrlData_0069            db 01,1,"Jack Ohman                              ",0,"http://picayune.uclick.com/comics/tmjoh",0;
UrlData_0070            db 01,1,"Pat Oliphant                            ",0,"http://picayune.uclick.com/comics/po",0;
UrlData_0071            db 01,1,"Joel Pett                               ",0,"http://picayune.uclick.com/comics/jp",0;
UrlData_0072            db 01,1,"Dwane Powell                            ",0,"http://picayune.uclick.com/comics/crdpo",0;
UrlData_0073            db 01,1,"Ted Rall                                ",0,"http://picayune.uclick.com/comics/tr",0;
UrlData_0074            db 01,1,"Steve Sack                              ",0,"http://picayune.uclick.com/comics/tmssa",0;
UrlData_0075            db 01,1,"Ben Sargent                             ",0,"http://picayune.uclick.com/comics/bs",0;
UrlData_0076            db 01,1,"Drew Sheneman                           ",0,"http://picayune.uclick.com/comics/tmdsh",0;
UrlData_0077            db 01,1,"Small World                             ",0,"http://picayune.uclick.com/comics/small",0;
UrlData_0078            db 01,1,"Wayne Stayskal                          ",0,"http://picayune.uclick.com/comics/tmwst",0;
UrlData_0079            db 01,1,"Dana Summers                            ",0,"http://picayune.uclick.com/comics/tmdsu",0;
UrlData_0080            db 01,1,"Paul Szep                               ",0,"http://picayune.uclick.com/comics/crpsz",0;
UrlData_0081            db 01,1,"Tom Toles                               ",0,"http://picayune.uclick.com/comics/tt",0;
UrlData_0082            db 01,1,"Gary Varvel                             ",0,"http://picayune.uclick.com/comics/crgva",0;
UrlData_0083            db 01,1,"ViewsAfrica                             ",0,"http://picayune.uclick.com/comics/cwvaf",0;
UrlData_0084            db 01,1,"ViewsAmerica                            ",0,"http://picayune.uclick.com/comics/cwvam",0;
UrlData_0085            db 01,1,"ViewsAsia                               ",0,"http://picayune.uclick.com/comics/cwvas",0;
UrlData_0086            db 01,1,"ViewsBusiness                           ",0,"http://picayune.uclick.com/comics/cwbus",0;
UrlData_0087            db 01,1,"ViewsEurope                             ",0,"http://picayune.uclick.com/comics/cwveu",0;
UrlData_0088            db 01,1,"ViewsLatinAmerica                       ",0,"http://picayune.uclick.com/comics/cwvla",0;
UrlData_0089            db 01,1,"ViewsMidEast                            ",0,"http://picayune.uclick.com/comics/cwvme",0;
UrlData_0090            db 01,1,"Views of the World                      ",0,"http://picayune.uclick.com/comics/cwvwo",0;
UrlData_0091            db 01,1,"Kerry Waghorn                           ",0,"http://picayune.uclick.com/comics/kw",0;
UrlData_0092            db 01,1,"Dan Wasserman                           ",0,"http://picayune.uclick.com/comics/tmdwa",0;
UrlData_0093            db 01,1,"Signe Wilkinson                         ",0,"http://picayune.uclick.com/comics/wpswi",0;
UrlData_0094            db 01,1,"Wit of the World                        ",0,"http://picayune.uclick.com/comics/cwwit",0;
UrlData_0095            db 01,1,"Don Wright                              ",0,"http://picayune.uclick.com/comics/tmdow",0;
UrlData_0096            db 01,4,"Steve Benson                            ",0,"http://picayune.uclick.com/comics/crsbe",0;
UrlData_0097            db 10,5,"Wiener Zeitung                          ",0,"http://www.goldcartoons.at/Cartoon/aktuell.jpg",0;
UrlData_0098            db 10,5,"Goldcartoons                            ",0,"http://www.goldcartoons.at/Cartoons/aktuell.jpg",0;
UrlData_0099            db 10,5,"Kleine Zeitung                          ",0,"http://www.goldcartoons.at/Cartoons/klz-aktuell.jpg",0;
;----------------------------------------------------------------------------------------------------
szNull                  db 0
szArial                 db "Arial",0
szLogo                  db "Logo",0
szUnderline             db "_",0
szSlash                 db "/",0
szDotgif                db ".gif",0
szDotjpg                db ".jpg",0
szDotpng                db ".png",0
szUnderlineGDotjpg      db "_G.jpg",0
szComaHome              db "Coma Homepage 20:00-23:00 GMT+2",0
szURLComa               db "http://ge2001.dyndns.org:44792",0



; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
.code
align 8
Main:
; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
invoke  GetModuleHandle,0
mov     wc.hInstance,eax
mov     hInstance,eax
;---
invoke  FindWindow,ADDR szCN,ADDR szWN
cmp     eax,0h
je      RunProgram
mov     ebx,eax
invoke  ShowWindow,ebx,SW_SHOWNORMAL
invoke  SetForegroundWindow,ebx
invoke  ExitProcess,wc.hInstance
mov     eax,msg.wParam
ret
;---
RunProgram:
finit                                           ; init FPU
invoke  AtlAxWinInit
;---
mov     icc.dwSize,sizeof INITCOMMONCONTROLSEX
mov     icc.dwICC,ICC_STANDARD_CLASSES or ICC_WIN95_CLASSES
invoke  InitCommonControlsEx,ADDR icc
;---
call    SubGetSystemMetrics
;---
invoke  LoadIcon,wc.hInstance,20000
mov     hIcoApplication,eax
mov     wc.hIconSm,eax
mov     wc.hIcon,eax
invoke  LoadCursor,0,IDC_ARROW
mov     wc.hCursor,eax
invoke  LoadBitmap,wc.hInstance,20001
mov     hBmpBackground,eax
invoke  CreatePatternBrush,hBmpBackground
mov     hBrBackground,eax
mov     wc.hbrBackground,eax
mov     wc.cbSize,sizeof WNDCLASSEX
mov     wc.style,CS_HREDRAW or CS_VREDRAW
mov     wc.lpfnWndProc,OFFSET WP
mov     wc.cbClsExtra,0
mov     wc.cbWndExtra,0
mov     wc.lpszMenuName,0
mov     wc.lpszClassName,OFFSET szCN
invoke  RegisterClassEx,ADDR wc
;---
invoke  CreateWindowEx,0,ADDR szCN,ADDR szWN,WS_OVERLAPPED or WS_CAPTION or WS_CLIPCHILDREN or WS_SYSMENU or WS_MINIMIZEBOX or WS_MAXIMIZEBOX,XorgWindow,YorgWindow,XmaxWindow,YmaxWindow,0,0,wc.hInstance,0
mov     msg.hwnd,eax
invoke  ShowWindow,msg.hwnd,SW_SHOWNORMAL
invoke  UpdateWindow,msg.hwnd



; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
MessageLoop:
; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
invoke  GetMessage,ADDR msg,0,0,0
cmp     eax,0h
je      TerminateProgram
invoke  TranslateMessage,ADDR msg
invoke  DispatchMessage,ADDR msg
jmp     MessageLoop
; -------------------------------------------------------------------------
TerminateProgram:
;invoke  AtlAxWinTerm
invoke  DeleteObject,hIcoApplication
invoke  DeleteObject,hBmpBackground
invoke  DeleteObject,hBrBackground
invoke  ExitProcess,wc.hInstance
mov     eax,msg.wParam
ret



; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
WP:                                             ; Window Procedure
; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
push    ebp
mov     ebp,esp
pushad
mov     eax,WP_uMsg
; -------------------------------------------------------------------------
WP_WM_CREATE:
cmp     eax,WM_CREATE
jne     WP_WM_DESTROY
; -------------------------------------------------------------------------
call    Sub_WMCreate
jmp     WP_Return

; -------------------------------------------------------------------------
WP_WM_DESTROY:
cmp     eax,WM_DESTROY
jne     WP_WM_SYSCOMMAND
; -------------------------------------------------------------------------
invoke  PostQuitMessage,0
popad
xor     eax,eax
mov     esp,ebp
pop     ebp
ret     10h

; -------------------------------------------------------------------------
WP_WM_SYSCOMMAND:
cmp     eax,WM_SYSCOMMAND
jne     WP_WM_SIZE
; -------------------------------------------------------------------------
mov     eax,WP_wParam
cmp     eax,SC_CLOSE
jne     WP_Return
invoke  AnimateWindow,WP_hWnd,500,AW_HIDE or AW_BLEND
call    SubCleanSystem
jmp     WP_Return

; -------------------------------------------------------------------------
WP_WM_SIZE:
cmp     eax,WM_SIZE
jne     WP_WM_PAINT
; -------------------------------------------------------------------------
mov     eax,WP_wParam
cmp     ax,SIZE_MINIMIZED
je      WP_WM_SIZE_MINIMIZED
cmp     ax,SIZE_MAXIMIZED
je      WP_WM_SIZE_MAXIMIZED
cmp     ax,SIZE_RESTORED
je      WP_WM_SIZE_RESTORED
jmp     WP_Return
;---
WP_WM_SIZE_MINIMIZED:
mov     nid.cbSize,sizeof nid
mov     eax,WP_hWnd
mov     nid.hwnd,eax
mov     nid.uID,0
mov     nid.uFlags,NIF_ICON or NIF_MESSAGE or NIF_TIP
mov     nid.uCallbackMessage,1280
mov     eax,hIcoApplication
mov     nid.hIcon,eax
invoke  lstrcpy,ADDR nid.szTip,ADDR szNull
invoke  ShowWindow,WP_hWnd,SW_HIDE
invoke  Shell_NotifyIcon,NIM_ADD,ADDR nid
jmp     WP_Return0
;---
WP_WM_SIZE_MAXIMIZED:
call    SubSize
jmp     WP_Return0
;---
WP_WM_SIZE_RESTORED:
call    SubSize
jmp     WP_Return0

; -------------------------------------------------------------------------
WP_WM_PAINT:
cmp     eax,WM_PAINT
jne     WP_WM_NOTIFY
; -------------------------------------------------------------------------

jmp     WP_Return

; -------------------------------------------------------------------------
WP_WM_NOTIFY:
cmp     eax,WM_NOTIFY
jne     WP_WM_DISPLAYCHANGE
; -------------------------------------------------------------------------
mov     ebx,WP_lParam 
mov     eax,[ebx+0]
;---
cmp     eax,hWndMC
jne     WP_Return
mov     eax,[ebx+8]
cmp     eax,MCN_SELCHANGE;MCN_SELECT
jne     WP_Return
call    URLBuilder
jmp     WP_Return

; -------------------------------------------------------------------------
WP_WM_DISPLAYCHANGE:
cmp     eax,WM_DISPLAYCHANGE
jne     WP_WM_NCMOUSEMOVE
; -------------------------------------------------------------------------
invoke  InvalidateRect,WP_hWnd,0,0
jmp     WP_Return

; -------------------------------------------------------------------------
WP_WM_NCMOUSEMOVE:
cmp     eax,WM_NCMOUSEMOVE
jne     WP_WM_USER
; -------------------------------------------------------------------------

jmp     WP_Return

; -------------------------------------------------------------------------
WP_WM_USER:
cmp     eax,1280
jne     WP_WM_COMMAND
; -------------------------------------------------------------------------
mov     eax,WP_wParam
cmp     ax,0
jne     WP_Return  
mov     eax,WP_lParam
cmp     eax,WM_LBUTTONDOWN
jne     WP_Return
invoke  SetForegroundWindow,WP_hWnd
invoke  Shell_NotifyIcon,NIM_DELETE,ADDR nid
invoke  ShowWindow,WP_hWnd,SW_RESTORE
jmp     WP_Return

; -------------------------------------------------------------------------
WP_WM_COMMAND:
cmp     eax,WM_COMMAND
jne     WP_WM_TIMER
mov     eax,WP_wParam                           ; control or menu ID in ax
; -------------------------------------------------------------------------
;jmp     WP_Return
WP_WM_COMMAND_2100:
cmp     ax,2100
jne     WP_WM_COMMAND_2200
shr     eax,16
cmp     eax,CBN_SELCHANGE
jne     WP_Return
call    URLBuilder
jmp     WP_Return
;---
WP_WM_COMMAND_2200:
cmp     ax,2200
jne     WP_WM_COMMAND_2400
invoke  ShellExecute,WP_hWnd,0,ADDR szURLComa,0,0,0 
jmp     WP_Return
;---
WP_WM_COMMAND_2400:
cmp     ax,2400
jne     WP_Return
shr     eax,16
cmp     eax,STN_CLICKED
jne     WP_Return
call    URLBuilder
jmp     WP_Return

; -------------------------------------------------------------------------
WP_WM_TIMER:
cmp     eax,WM_TIMER
jne     WP_WM_CTLCOLORBTN
; -------------------------------------------------------------------------

jmp     WP_Return

; -------------------------------------------------------------------------
WP_WM_CTLCOLORBTN:
cmp     eax,WM_CTLCOLORBTN
jne     WP_WM_CTLCOLORSTATIC
; -------------------------------------------------------------------------

jmp     WP_Return

; -------------------------------------------------------------------------
WP_WM_CTLCOLORSTATIC:
cmp     eax,WM_CTLCOLORSTATIC
jne     WP_WM_CTLCOLOREDIT
; -------------------------------------------------------------------------
mov     eax,WP_lParam
cmp     eax,hWndSTCount
jne     WP_Return
WP_WM_CTLCOLORSTATIC_Go:
invoke  SetBkMode,WP_wParam,TRANSPARENT
invoke  SetBkColor,WP_wParam,0
invoke  SetTextColor,WP_wParam,0000E000h
mov     eax,hBrBLACK_BRUSH
mov     ReturnEAX,eax
jmp     WP_ReturnEAX


; -------------------------------------------------------------------------
WP_WM_CTLCOLOREDIT:
cmp     eax,WM_CTLCOLOREDIT
jne     WP_WM_CTLCOLORLISTBOX
; -------------------------------------------------------------------------

jmp     WP_Return

; -------------------------------------------------------------------------
WP_WM_CTLCOLORLISTBOX:
cmp     eax,WM_CTLCOLORLISTBOX
jne     WP_WM_WINDOWPOSCHANGING
; -------------------------------------------------------------------------

jmp     WP_Return

; -------------------------------------------------------------------------
WP_WM_WINDOWPOSCHANGING:
cmp     eax,WM_WINDOWPOSCHANGING
jne     WP_WM_DRAWITEM
; -------------------------------------------------------------------------

jmp     WP_Return

; -------------------------------------------------------------------------
WP_WM_DRAWITEM:
cmp     eax,WM_DRAWITEM
jne     WP_WM_PARENTNOTIFY
; -------------------------------------------------------------------------

jmp     WP_Return

; -------------------------------------------------------------------------
WP_WM_PARENTNOTIFY:
cmp     eax,WM_PARENTNOTIFY
jne     WP_WM_RBUTTONDOWN
; -------------------------------------------------------------------------

jmp     WP_Return

; -------------------------------------------------------------------------
WP_WM_RBUTTONDOWN:
cmp     eax,WM_RBUTTONDOWN
jne     WP_WM_MOUSEMOVE
; -------------------------------------------------------------------------

jmp     WP_Return

; -------------------------------------------------------------------------
WP_WM_MOUSEMOVE:
cmp     eax,WM_MOUSEMOVE
jne     WP_WM_CONTEXTMENU
; -------------------------------------------------------------------------

jmp     WP_Return

; -------------------------------------------------------------------------
WP_WM_CONTEXTMENU:
cmp     eax,WM_CONTEXTMENU
jne     WP_WM_POWERBROADCAST
; -------------------------------------------------------------------------

jmp     WP_Return

; -------------------------------------------------------------------------
WP_WM_POWERBROADCAST:
cmp     eax,WM_POWERBROADCAST
jne     WP_WM_ERASEBKGND
; -------------------------------------------------------------------------
mov     eax,WP_wParam
cmp     eax,PBT_APMRESUMESUSPEND
jne     WP_Return
mov     eax,WP_lParam
cmp     eax,PBTF_APMRESUMEFROMFAILURE
je      WP_Return
invoke  RedrawWindow,WP_hWnd,0,0,RDW_ERASE or RDW_INVALIDATE or RDW_UPDATENOW
jmp     WP_Return

; -------------------------------------------------------------------------
WP_WM_ERASEBKGND:
cmp     eax,WM_ERASEBKGND
jne     WP_WM_ACTIVATE
; -------------------------------------------------------------------------

jmp     WP_Return

; -------------------------------------------------------------------------
WP_WM_ACTIVATE:
cmp     eax,WM_ACTIVATE
jne     WP_WM_HSCROLL
; -------------------------------------------------------------------------

jmp     WP_Return

; -------------------------------------------------------------------------
WP_WM_HSCROLL:
cmp     eax,WM_HSCROLL
jne     WP_WM_VSCROLL
; -------------------------------------------------------------------------

jmp     WP_Return

; -------------------------------------------------------------------------
WP_WM_VSCROLL:
cmp     eax,WM_VSCROLL
jne     WP_WM_SYNCPAINT
; -------------------------------------------------------------------------
mov     eax,WP_lParam
cmp     eax,hWndUDCount
jne     WP_Return
call    URLBuilder
jmp     WP_Return

; -------------------------------------------------------------------------
WP_WM_SYNCPAINT:
cmp     eax,WM_SYNCPAINT
jne     WP_Return
; -------------------------------------------------------------------------

jmp     WP_Return

; -------------------------------------------------------------------------
WP_Return:
; -------------------------------------------------------------------------
popad
invoke  DefWindowProc,WP_hWnd,WP_uMsg,WP_wParam,WP_lParam
mov     esp,ebp                                 ; delete stack frame
pop     ebp
ret     10h                                     ; return and clear stack
; -------------------------------------------------------------------------
WP_Return0:
; -------------------------------------------------------------------------
popad
mov     eax,0
mov     esp,ebp                                 ; delete stack frame
pop     ebp
ret     10h                                     ; return and clear stack
; -------------------------------------------------------------------------
WP_Return1:
; -------------------------------------------------------------------------
popad
mov     eax,1
mov     esp,ebp                                 ; delete stack frame
pop     ebp
ret     10h                                     ; return and clear stack
; -------------------------------------------------------------------------
WP_ReturnEAX:
; -------------------------------------------------------------------------
popad
mov     eax,ReturnEAX
mov     esp,ebp                                 ; delete stack frame
pop     ebp
ret     10h                                     ; return and clear stack
; -------------------------------------------------------------------------



; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; SubRoutines
; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
SubGetSystemMetrics:
invoke  GetSystemMetrics,SM_CXSCREEN
cmp     eax,XmaxWindow
jbe     SubGetSystemMetricsRet
shr     eax,1
mov     ebx,XmaxWindow
shr     ebx,1
sub     eax,ebx
mov     XorgWindow,eax
invoke  GetSystemMetrics,SM_CYSCREEN
cmp     eax,YmaxWindow
jbe     SubGetSystemMetricsRet
shr     eax,1
mov     ebx,YmaxWindow
shr     ebx,1
sub     eax,ebx
mov     YorgWindow,eax
;---
SubGetSystemMetricsRet:
ret

; -------------------------------------------------------------------------
Sub_WMCreate:
; -------------------------------------------------------------------------
invoke  CreateFont,80,40,0,0,500,0,0,0,1,0,0,2,0,ADDR szArial
mov     hFntArial,eax
invoke  GetStockObject,BLACK_BRUSH
mov     hBrBLACK_BRUSH,eax
invoke  GetStockObject,DEFAULT_GUI_FONT
mov     hFntDefGui,eax
invoke  SendMessage,WP_hWnd,WM_SETFONT,hFntDefGui,1
;---
invoke  ImageList_Create,18,12,ILC_COLOR8,4,0
mov     hWndIL,eax
invoke  LoadBitmap,wc.hInstance,20100
mov     hBmpTmp,eax
invoke  ImageList_Add,hWndIL,hBmpTmp,0
invoke  DeleteObject,hBmpTmp
invoke  LoadBitmap,wc.hInstance,20101
mov     hBmpTmp,eax
invoke  ImageList_Add,hWndIL,hBmpTmp,0
invoke  DeleteObject,hBmpTmp
invoke  LoadBitmap,wc.hInstance,20102
mov     hBmpTmp,eax
invoke  ImageList_Add,hWndIL,hBmpTmp,0
invoke  DeleteObject,hBmpTmp
invoke  LoadBitmap,wc.hInstance,20103
mov     hBmpTmp,eax
invoke  ImageList_Add,hWndIL,hBmpTmp,0
invoke  DeleteObject,hBmpTmp
invoke  LoadBitmap,wc.hInstance,20104
mov     hBmpTmp,eax
invoke  ImageList_Add,hWndIL,hBmpTmp,0
invoke  DeleteObject,hBmpTmp
invoke  LoadBitmap,wc.hInstance,20105
mov     hBmpTmp,eax
invoke  ImageList_Add,hWndIL,hBmpTmp,0
invoke  DeleteObject,hBmpTmp
;---
invoke  CreateWindowEx,0,ADDR szCN_Calendar,0,WS_CHILD or WS_VISIBLE or WS_BORDER or WS_CLIPSIBLINGS or MCS_DAYSTATE,0,0,0,0,WP_hWnd,2000,wc.hInstance,0
mov     hWndMC,eax
invoke  SendMessage,hWndMC,MCM_SETCOLOR,MCSC_TITLEBK,00000000h
invoke  SendMessage,hWndMC,MCM_SETCOLOR,MCSC_TITLETEXT,0000D6FFh
invoke  SendMessage,hWndMC,MCM_SETCOLOR,MCSC_BACKGROUND,00FFD600h
invoke  SendMessage,hWndMC,MCM_SETCOLOR,MCSC_MONTHBK,00FFD600h
invoke  SendMessage,hWndMC,MCM_GETMINREQRECT,0,ADDR rc
mov     eax,rc.right
mov     XmaxMC,eax
mov     eax,rc.bottom
mov     YmaxMC,eax
invoke  SetWindowPos,hWndMC,0,8,8,rc.right,rc.bottom,SWP_NOZORDER
;---
mov     esi,rc.right
add     esi,16
mov     edi,rc.bottom
shr     edi,1
invoke  CreateWindowEx,0,ADDR szCN_Static,0,WS_CHILD or WS_BORDER or WS_CLIPSIBLINGS or SS_CENTER or SS_NOTIFY,8,8,esi,edi,WP_hWnd,2400,wc.hInstance,0
mov     hWndSTCount,eax
invoke  SendMessage,hWndSTCount,WM_SETFONT,hFntArial,1
invoke  SendMessage,hWndSTCount,EM_LIMITTEXT,3,0
invoke  CreateUpDownControl,WS_CHILD or WS_BORDER or WS_CLIPSIBLINGS or UDS_AUTOBUDDY or UDS_SETBUDDYINT or UDS_WRAP or UDS_ARROWKEYS or UDS_NOTHOUSANDS or UDS_ALIGNRIGHT or UDS_HOTTRACK,0,0,0,0,WP_hWnd,2410,wc.hInstance,hWndSTCount,999,1,1
mov     hWndUDCount,eax
;---
add     rc.right,24
invoke  CreateWindowEx,0,ADDR szCN_ComboBoxEx,0,WS_CHILD or WS_VISIBLE or WS_BORDER or WS_CLIPSIBLINGS or WS_BORDER or WS_VSCROLL or CBS_NOINTEGRALHEIGHT or CBS_DROPDOWNLIST,rc.right,8,320,rc.bottom,WP_hWnd,2100,wc.hInstance,0
mov     hWndCBCartoonSource,eax
invoke  SendMessage,hWndCBCartoonSource,WM_SETFONT,hFntDefGui,1h
invoke  SendMessage,hWndCBCartoonSource,CBEM_SETIMAGELIST,0,hWndIL
mov     cbei._mask,CBEIF_IMAGE or CBEIF_SELECTEDIMAGE or CBEIF_TEXT or CBEIF_LPARAM
mov     cbei.iItem,-1
mov     ebx,0
mov     esi,OFFSET UrlDataTable
CBEX_Loop:
mov     eax,[esi]
mov     cbei.lParam,eax
inc     eax
mov     edx,[eax]
and     edx,0FFh
mov     cbei.iImage,edx
mov     cbei.iSelectedImage,edx
inc     eax
mov     cbei.pszText,eax
invoke  SendMessage,hWndCBCartoonSource,CBEM_INSERTITEM,0,ADDR cbei
add     esi,4
inc     ebx
cmp     ebx,100
jne     CBEX_Loop
invoke  SendMessage,hWndCBCartoonSource,CB_SETCURSEL,0,0
;---
invoke  CreateWindowEx,0,ADDR szCN_Static,ADDR szLogo,WS_CHILD or WS_VISIBLE or WS_CLIPSIBLINGS or WS_BORDER or SS_BITMAP or SS_REALSIZECONTROL or SS_NOTIFY,592,8,200,64,WP_hWnd,2200,wc.hInstance,0
mov     hWndSTLogo,eax
;---
mov     esi,YmaxWindow
sub     esi,176
invoke  CreateWindowEx,0,ADDR szCN_Atl,ADDR UrlDataBlank,WS_CHILD or WS_VISIBLE or WS_CLIPSIBLINGS or WS_VSCROLL,0,176,XmaxWindow,esi,WP_hWnd,6000,wc.hInstance,0
mov     hWndAtl,eax
;---
invoke  CreateWindowEx,WS_EX_TOPMOST,ADDR szCN_ToolTips,0,WS_VISIBLE or WS_POPUP or TTS_NOPREFIX or TTS_ALWAYSTIP or TTS_BALLOON,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,0,0,wc.hInstance,0
mov     hWndTT,eax
invoke  SetWindowPos,hWndTT,HWND_TOPMOST,0,0,0,0,SWP_NOMOVE or SWP_NOSIZE or SWP_NOACTIVATE
invoke  SendMessage,hWndTT,TTM_SETTITLE,1,ADDR szComaHome
mov     ti.cbSize,sizeof ti
mov     eax,WP_hWnd
mov     ti.hWnd,eax 
mov     ti.uFlags,TTF_SUBCLASS or TTF_IDISHWND
mov     eax,hWndSTLogo
mov     ti.uId,eax
mov     ti.lpszText,OFFSET szURLComa
invoke  SendMessage,hWndTT,TTM_ADDTOOL,0,ADDR ti
;---
mov     eax,WP_hWnd                                 ; Bugfix starts here, Microsoft doesn't solve it since years !
mov     ti.uId,eax
mov     ti.lpszText,OFFSET szNull
invoke  SendMessage,hWndTT,TTM_ADDTOOL,0,ADDR ti    ; Bugfix ends here
invoke  SendMessage,hWndTT,TTM_ACTIVATE,1,ADDR ti
;---
ret

; -------------------------------------------------------------------------
SubSize:
; -------------------------------------------------------------------------
invoke  GetClientRect,WP_hWnd,ADDR rc
mov     eax,rc.right
mov     XmaxWindow,eax
mov     eax,rc.bottom
mov     YmaxWindow,eax
;---
mov     esi,rc.right
sub     esi,8
sub     esi,200
invoke  SetWindowPos,hWndSTLogo,0,esi,8,200,64,SWP_NOZORDER
;---
invoke  GetClientRect,WP_hWnd,ADDR rc
mov     esi,rc.right
sub     esi,8
sub     esi,XmaxMC
sub     esi,16
sub     esi,16
sub     esi,200
sub     esi,8
invoke  SetWindowPos,hWndCBCartoonSource,0,0,0,esi,YmaxMC,SWP_NOMOVE or SWP_NOZORDER
;---
call    URLBuilder
ret

; -------------------------------------------------------------------------
URLBuilder:
; -------------------------------------------------------------------------
invoke  SendMessage,hWndCBCartoonSource,CB_GETCURSEL,0,0
cmp     eax,CB_ERR
je      URLBuilderReturn
cmp     eax,0
jne     URLBuilderCartoonON
;---
URLBuilderOFF:
call    HideControls
invoke  DestroyWindow,hWndAtl
mov     esi,YmaxWindow
sub     esi,176
invoke  CreateWindowEx,0,ADDR szCN_Atl,ADDR UrlDataBlank,WS_CHILD or WS_VISIBLE or WS_CLIPSIBLINGS or WS_VSCROLL,0,176,XmaxWindow,esi,WP_hWnd,6000,wc.hInstance,0
mov     hWndAtl,eax
jmp     URLBuilderReturn
;---
URLBuilderCartoonON:
invoke  SendMessage,hWndCBCartoonSource,CB_GETITEMDATA,eax,0
cmp     eax,CB_ERR
je      URLBuilderReturn
;---
mov     ebx,eax
mov     dl,[ebx]
add     ebx,43
cmp     dl,01
je      URLBuilderMethod01
cmp     dl,02
je      URLBuilderMethod02
cmp     dl,03
je      URLBuilderMethod03
cmp     dl,04
je      URLBuilderMethod04
cmp     dl,05
je      URLBuilderMethod05
cmp     dl,06
je      URLBuilderMethod06
cmp     dl,07
je      URLBuilderMethod07
cmp     dl,08
je      URLBuilderMethod08
cmp     dl,09
je      URLBuilderMethod09
cmp     dl,10
je      URLBuilderMethod10
cmp     dl,11
je      URLBuilderMethod11
cmp     dl,12
je      URLBuilderMethod12
cmp     dl,13
je      URLBuilderMethod13
jmp     URLBuilderReturn
;---
URLBuilderMethod01:
call    ShowMC
invoke  lstrcpy,ADDR BufferURL,ADDR UrlDataBegin
invoke  lstrcat,ADDR BufferURL,ebx
invoke  StrRChr,ebx,0,2Fh
invoke  lstrcpy,ADDR BufferTmp0,eax
invoke  lstrcat,ADDR BufferURL,ADDR szSlash
invoke  SendMessage,hWndMC,MCM_GETCURSEL,0,ADDR _st
mov     eax,0
mov     edi,OFFSET BufferTmp1
mov     ax,_st.wYear
call    SubHexDDtoStringDec
invoke  lstrcat,ADDR BufferURL,ADDR BufferTmp1+6
invoke  lstrcat,ADDR BufferURL,ADDR BufferTmp0
invoke  lstrcat,ADDR BufferURL,ADDR BufferTmp1+8
mov     eax,0
mov     edi,OFFSET BufferTmp1
mov     ax,_st.wMonth
call    SubHexDDtoStringDec
invoke  lstrcat,ADDR BufferURL,ADDR BufferTmp1+8
mov     eax,0
mov     edi,OFFSET BufferTmp1
mov     ax,_st.wDay
call    SubHexDDtoStringDec
invoke  lstrcat,ADDR BufferURL,ADDR BufferTmp1+8
invoke  lstrcat,ADDR BufferURL,ADDR szDotgif
invoke  lstrcat,ADDR BufferURL,ADDR UrlDataEnd
;invoke  MessageBox,WP_hWnd,ADDR BufferURL,ADDR szLogo,MB_OK
jmp     URLBuilderLoad
;---
URLBuilderMethod02:
call    ShowMC
invoke  lstrcpy,ADDR BufferURL,ADDR UrlDataBegin
invoke  lstrcat,ADDR BufferURL,ebx
invoke  SendMessage,hWndMC,MCM_GETCURSEL,0,ADDR _st
mov     eax,0
mov     edi,OFFSET BufferTmp1
mov     ax,_st.wYear
call    SubHexDDtoStringDec
invoke  lstrcat,ADDR BufferURL,ADDR BufferTmp1+6
mov     eax,0
mov     edi,OFFSET BufferTmp1
mov     ax,_st.wMonth
call    SubHexDDtoStringDec
invoke  lstrcat,ADDR BufferURL,ADDR BufferTmp1+8
mov     eax,0
mov     edi,OFFSET BufferTmp1
mov     ax,_st.wDay
call    SubHexDDtoStringDec
invoke  lstrcat,ADDR BufferURL,ADDR BufferTmp1+8
invoke  lstrcat,ADDR BufferURL,ADDR szDotgif
invoke  lstrcat,ADDR BufferURL,ADDR UrlDataEnd
;invoke  MessageBox,WP_hWnd,ADDR BufferURL,ADDR szLogo,MB_OK
jmp     URLBuilderLoad
;---
URLBuilderMethod03:
call    ShowUD
invoke  lstrcpy,ADDR BufferURL,ADDR UrlDataBegin
invoke  lstrcat,ADDR BufferURL,ebx
invoke  GetWindowText,hWndSTCount,ADDR BufferTmp1,4
invoke  lstrcat,ADDR BufferURL,ADDR BufferTmp1
invoke  lstrcat,ADDR BufferURL,ADDR szDotpng
invoke  lstrcat,ADDR BufferURL,ADDR UrlDataEnd
;invoke  MessageBox,WP_hWnd,ADDR BufferURL,ADDR szLogo,MB_OK
jmp     URLBuilderLoad
;---
URLBuilderMethod04:
call    ShowMC
invoke  lstrcpy,ADDR BufferURL,ADDR UrlDataBegin
invoke  lstrcat,ADDR BufferURL,ebx
invoke  SendMessage,hWndMC,MCM_GETCURSEL,0,ADDR _st
mov     eax,0
mov     edi,OFFSET BufferTmp1
mov     ax,_st.wYear
call    SubHexDDtoStringDec
invoke  lstrcat,ADDR BufferURL,ADDR BufferTmp1+8
mov     eax,0
mov     edi,OFFSET BufferTmp1
mov     ax,_st.wMonth
call    SubHexDDtoStringDec
invoke  lstrcat,ADDR BufferURL,ADDR BufferTmp1+8
mov     eax,0
mov     edi,OFFSET BufferTmp1
mov     ax,_st.wDay
call    SubHexDDtoStringDec
invoke  lstrcat,ADDR BufferURL,ADDR BufferTmp1+8
invoke  lstrcat,ADDR BufferURL,ADDR szDotjpg
invoke  lstrcat,ADDR BufferURL,ADDR UrlDataEnd
;invoke  MessageBox,WP_hWnd,ADDR BufferURL,ADDR szLogo,MB_OK
jmp     URLBuilderLoad
;---
URLBuilderMethod05:
call    ShowMC
invoke  lstrcpy,ADDR BufferURL,ADDR UrlDataBegin
invoke  lstrcat,ADDR BufferURL,ebx
invoke  StrRChr,ebx,0,2Fh
invoke  lstrcpy,ADDR BufferTmp0,eax
invoke  SendMessage,hWndMC,MCM_GETCURSEL,0,ADDR _st
mov     eax,0
mov     edi,OFFSET BufferTmp1
mov     ax,_st.wYear
call    SubHexDDtoStringDec
invoke  lstrcat,ADDR BufferURL,ADDR szUnderline
invoke  lstrcat,ADDR BufferURL,ADDR BufferTmp1+6
invoke  lstrcat,ADDR BufferURL,ADDR BufferTmp0
mov     eax,0
mov     edi,OFFSET BufferTmp1
mov     ax,_st.wMonth
call    SubHexDDtoStringDec
invoke  lstrcat,ADDR BufferURL,ADDR BufferTmp1+8
mov     eax,0
mov     edi,OFFSET BufferTmp1
mov     ax,_st.wDay
call    SubHexDDtoStringDec
invoke  lstrcat,ADDR BufferURL,ADDR BufferTmp1+8
invoke  lstrcat,ADDR BufferURL,ADDR szDotgif
invoke  lstrcat,ADDR BufferURL,ADDR UrlDataEnd
;invoke  MessageBox,WP_hWnd,ADDR BufferURL,ADDR szLogo,MB_OK
jmp     URLBuilderLoad
;---
URLBuilderMethod06:
call    ShowMC
invoke  lstrcpy,ADDR BufferURL,ADDR UrlDataBegin
invoke  lstrcat,ADDR BufferURL,ebx
invoke  SendMessage,hWndMC,MCM_GETCURSEL,0,ADDR _st
mov     eax,0
mov     edi,OFFSET BufferTmp1
mov     ax,_st.wYear
call    SubHexDDtoStringDec
invoke  lstrcat,ADDR BufferURL,ADDR BufferTmp1+8
mov     eax,0
mov     edi,OFFSET BufferTmp1
mov     ax,_st.wMonth
call    SubHexDDtoStringDec
invoke  lstrcat,ADDR BufferURL,ADDR BufferTmp1+8
mov     eax,0
mov     edi,OFFSET BufferTmp1
mov     ax,_st.wDay
call    SubHexDDtoStringDec
invoke  lstrcat,ADDR BufferURL,ADDR BufferTmp1+8
invoke  lstrcat,ADDR BufferURL,ADDR szDotgif
invoke  lstrcat,ADDR BufferURL,ADDR UrlDataEnd
;invoke  MessageBox,WP_hWnd,ADDR BufferURL,ADDR szLogo,MB_OK
jmp     URLBuilderLoad
;---
URLBuilderMethod07:
call    ShowMC
invoke  lstrcpy,ADDR BufferURL,ADDR UrlDataBegin
invoke  lstrcat,ADDR BufferURL,ebx
invoke  SendMessage,hWndMC,MCM_GETCURSEL,0,ADDR _st
mov     eax,0
mov     edi,OFFSET BufferTmp1
mov     ax,_st.wYear
call    SubHexDDtoStringDec
invoke  lstrcat,ADDR BufferURL,ADDR BufferTmp1+6
invoke  lstrcat,ADDR BufferURL,ADDR szSlash
mov     eax,0
mov     edi,OFFSET BufferTmp1
mov     ax,_st.wMonth
call    SubHexDDtoStringDec
mov     ebx,OFFSET BufferTmp1
add     ebx,8
mov     eax,30h
cmp     [ebx],al
jne     URLBuilderMethod07SetMonth
inc     ebx
URLBuilderMethod07SetMonth:
invoke  lstrcat,ADDR BufferURL,ebx
invoke  lstrcat,ADDR BufferURL,ADDR szSlash
mov     eax,0
mov     edi,OFFSET BufferTmp1
mov     ax,_st.wDay
call    SubHexDDtoStringDec
mov     ebx,OFFSET BufferTmp1
add     ebx,8
mov     eax,30h
cmp     [ebx],al
jne     URLBuilderMethod07Go
inc     ebx
URLBuilderMethod07Go:
invoke  lstrcat,ADDR BufferURL,ebx
invoke  lstrcat,ADDR BufferURL,ADDR szDotjpg
invoke  lstrcat,ADDR BufferURL,ADDR UrlDataEnd
;invoke  MessageBox,WP_hWnd,ADDR BufferURL,ADDR szLogo,MB_OK
jmp     URLBuilderLoad
;---
URLBuilderMethod08:
call    ShowUD
invoke  lstrcpy,ADDR BufferURL,ADDR UrlDataBegin
invoke  lstrcat,ADDR BufferURL,ebx
invoke  SendMessage,hWndUDCount,UDM_GETPOS,0,0
mov     edi,OFFSET BufferTmp1
call    SubHexDDtoStringDec
invoke  lstrcat,ADDR BufferURL,ADDR BufferTmp1+7
invoke  lstrcat,ADDR BufferURL,ADDR szUnderlineGDotjpg
invoke  lstrcat,ADDR BufferURL,ADDR UrlDataEnd
;invoke  MessageBox,WP_hWnd,ADDR BufferURL,ADDR szLogo,MB_OK
jmp     URLBuilderLoad
;---
URLBuilderMethod09:
call    ShowUD
invoke  lstrcpy,ADDR BufferURL,ADDR UrlDataBegin
invoke  lstrcat,ADDR BufferURL,ebx
invoke  SendMessage,hWndUDCount,UDM_GETPOS,0,0
mov     edi,OFFSET BufferTmp1
call    SubHexDDtoStringDec
invoke  lstrcat,ADDR BufferURL,ADDR BufferTmp1+7
invoke  lstrcat,ADDR BufferURL,ADDR szDotgif
invoke  lstrcat,ADDR BufferURL,ADDR UrlDataEnd
;invoke  MessageBox,WP_hWnd,ADDR BufferURL,ADDR szLogo,MB_OK
jmp     URLBuilderLoad
;---
URLBuilderMethod10:
call    HideControls
invoke  lstrcpy,ADDR BufferURL,ADDR UrlDataBegin
invoke  lstrcat,ADDR BufferURL,ebx
invoke  lstrcat,ADDR BufferURL,ADDR UrlDataEnd
;invoke  MessageBox,WP_hWnd,ADDR BufferURL,ADDR szLogo,MB_OK
jmp     URLBuilderLoad
;---
URLBuilderMethod11:
call    ShowUD
invoke  lstrcpy,ADDR BufferURL,ADDR UrlDataBegin
invoke  lstrcat,ADDR BufferURL,ebx
invoke  SendMessage,hWndUDCount,UDM_GETPOS,0,0
mov     edi,OFFSET BufferTmp1
call    SubHexDDtoStringDec
invoke  lstrcat,ADDR BufferURL,ADDR BufferTmp1+7
invoke  lstrcat,ADDR BufferURL,ADDR szSlash
invoke  lstrcat,ADDR BufferURL,ADDR BufferTmp1+7
invoke  lstrcat,ADDR BufferURL,ADDR szDotgif
invoke  lstrcat,ADDR BufferURL,ADDR UrlDataEnd
;invoke  MessageBox,WP_hWnd,ADDR BufferURL,ADDR szLogo,MB_OK
jmp     URLBuilderLoad
;---
URLBuilderMethod12:
call    ShowUD
invoke  lstrcpy,ADDR BufferURL,ADDR UrlDataBegin
invoke  lstrcat,ADDR BufferURL,ebx
invoke  SendMessage,hWndUDCount,UDM_GETPOS,0,0
mov     edi,OFFSET BufferTmp1
call    SubHexDDtoStringDec
invoke  lstrcat,ADDR BufferURL,ADDR BufferTmp1+7
invoke  lstrcat,ADDR BufferURL,ADDR szSlash
invoke  lstrcat,ADDR BufferURL,ADDR BufferTmp1+7
invoke  lstrcat,ADDR BufferURL,ADDR szDotjpg
invoke  lstrcat,ADDR BufferURL,ADDR UrlDataEnd
;invoke  MessageBox,WP_hWnd,ADDR BufferURL,ADDR szLogo,MB_OK
jmp     URLBuilderLoad
;---
URLBuilderMethod13:
call    ShowUD
invoke  lstrcpy,ADDR BufferURL,ADDR UrlDataBegin
invoke  lstrcat,ADDR BufferURL,ebx
invoke  SendMessage,hWndUDCount,UDM_GETPOS,0,0
mov     edi,OFFSET BufferTmp1
call    SubHexDDtoStringDec
invoke  lstrcat,ADDR BufferURL,ADDR BufferTmp1+7
invoke  lstrcat,ADDR BufferURL,ADDR szSlash
invoke  lstrcat,ADDR BufferURL,ADDR BufferTmp1+7
invoke  lstrcat,ADDR BufferURL,ADDR szDotgif
invoke  lstrcat,ADDR BufferURL,ADDR UrlDataEnd
;invoke  MessageBox,WP_hWnd,ADDR BufferURL,ADDR szLogo,MB_OK
jmp     URLBuilderLoad
;---
URLBuilderLoad:
mov     esi,YmaxWindow
sub     esi,176
invoke  DestroyWindow,hWndAtl
invoke  CreateWindowEx,0,ADDR szCN_Atl,ADDR BufferURL,WS_VISIBLE or WS_CHILD or WS_CLIPSIBLINGS or WS_VSCROLL,0,176,XmaxWindow,esi,WP_hWnd,6000,wc.hInstance,0
mov     hWndAtl,eax
ret
;---
URLBuilderReturn:
ret

; -------------------------------------------------------------------------
HideControls:
; -------------------------------------------------------------------------
invoke  ShowWindow,hWndSTCount,SW_HIDE
invoke  ShowWindow,hWndUDCount,SW_HIDE
invoke  ShowWindow,hWndMC,SW_HIDE
ret

; -------------------------------------------------------------------------
ShowMC:
; -------------------------------------------------------------------------
invoke  ShowWindow,hWndSTCount,SW_HIDE
invoke  ShowWindow,hWndUDCount,SW_HIDE
invoke  ShowWindow,hWndMC,SW_SHOW
ret

; -------------------------------------------------------------------------
ShowUD:
; -------------------------------------------------------------------------
invoke  ShowWindow,hWndMC,SW_HIDE
invoke  ShowWindow,hWndSTCount,SW_SHOW
invoke  ShowWindow,hWndUDCount,SW_SHOW
ret

; -------------------------------------------------------------------------
SubCleanSystem:
; -------------------------------------------------------------------------
invoke  Shell_NotifyIcon,NIM_DELETE,ADDR nid
invoke  ImageList_Destroy,hWndIL
invoke  DeleteObject,hFntArial
invoke  DestroyWindow,hWndTT
invoke  DestroyWindow,hWndMC
invoke  DestroyWindow,hWndCBCartoonSource
invoke  DestroyWindow,hWndSTLogo
invoke  DestroyWindow,hWndAtl
invoke  DestroyWindow,hWndSTCount
invoke  DestroyWindow,hWndUDCount
ret

;--------------------------------------------------------------------------
SubHexDDtoStringDec:        ;EAX=Hex, EDI=pBuffer, Made by tE! // TMG
;--------------------------------------------------------------------------
push    0h                  ;get additional space on stack (10 bytes min.)
push    0h                  ;'' upper dword is 0
push    eax                 ;'' lower dword -> 32 bit integer to convert
fild    qword ptr[esp]      ;load 64 bit integer value on TOS
fbstp   real10 ptr[esp]     ; store value as 80bit BCD value
pop     ecx
pop     eax
mov     edx,ecx
mov     ebx,eax
shr     ecx,4
shr     eax,4
and     ebx,0000000Fh       ;mask nibbles
and     edx,0F0F0F0Fh       ;...
and     ecx,0F0F0F0Fh
add     edx,30303030h       ;build ascii numbers
add     ecx,30303030h       ;...
add     eax,30h
add     ebx,30h
mov     [edi],al            ;store in buffer
mov     [edi+1],bl          ;...
mov     [edi+8],cl
mov     [edi+9],dl
mov     [edi+6],ch
mov     [edi+7],dh
bswap   ecx                 ;endian conversion (486 processor needed)
bswap   edx                 ;dto.
mov     [edi+2],cl
mov     [edi+3],dl
mov     [edi+4],ch
mov     [edi+5],dh
pop     eax                 ;correct stack
ret

; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
end Main
; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
